<!DOCTYPE html>
<html>
	<head>
		<title>Linner Kodlar</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=edge" />
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<script type="text/javascript" src="jquery-1.10.2.js"></script>
		<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
		<script type="text/javascript" src="calculationlib/ecclib.js"></script>
		<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
		<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
		<script type="text/x-mathjax-config">
			MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
			MathJax.Localization.setLocale("tr");
		</script>
		<script>
			var aggregate = function(arr, seed, func) {
				var accumulate = seed;
				for(var i = 0; i < arr.length; i++)
					accumulate = func(accumulate, arr[i]);
				return accumulate;
			}
			var AddFormula = function(container, name, tex) {
				var containerSelector = $('#' + container);
				if ($('#' + name).length == 0)
					containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
				else $('#' + name).html("");

				$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
				MathJax.Hub.Queue(["Typeset",MathJax.Hub]);
			}
			var CreateTable = function(div, name, colCount, rowCount) {
				var table = "<table id=" + name + ">";
				for (var i = 0; i < rowCount; i++) {
					table += "<tr id = tr_" + name + "_" + i + ">";
					for (var j = 0; j < colCount; j++) {
						table += "<td id=td_" + name + "_" + j + "_" + i + "> </td>";
					}
					table += "</tr>";
				}
				table += "</table>";
				$("#" + div).append(table);
			}
			var ReadMatrix = function(text) {
				
				var data = [];
				text = text.replace( /\s\s+/g, ' ' );
				var lines = text.split(/\r|\n/);
				for (var i = 0; i < lines.length; i++) {
					var lineData = [];
					var cells = lines[i].split(' ');
					for (var j = 0; j < cells.length; j++) {
						if(cells[j] != "") {
							lineData.push(parseInt(cells[j]));
						}
					}
					if (lineData.length > 0)
						data.push(lineData);
				}
				return data;
			}
		</script>
		<style>
		#result td {
			text-align: center;
			padding: 2px ;
			border: 1px black solid;
		}
		
		table[id=result] {
			border-collapse: collapse;
			margin-left:auto; 
			margin-right:auto;
			margin-top: 15px;
		}
		
		textarea {
		  white-space: pre;
		  overflow-wrap: normal;
		  overflow-x: auto;
		}

		</style>
	</head>

	<body>
		
		<table>
		<tr>
			<td> <label class="col-sm-2 control-label"><b>GF</b></label> </td> 
			<td> <input type="text" id="txtDegree" value="2" disabled/> </td>
		</tr>
		<tr>
			<td> <label class="col-sm-2 control-label"><b>Üreteç <br />Matris</b></label> </td> 
			<td><!--<input type="text" id="txtGeneratorMatrix" value="[[1,1,1,1,1,1,1],[1,0,0,0,1,0,1],[1,1,0,0,0,1,0],[0,1,1,0,0,0,1]]"/>-->
			<textarea class="form-control" id="txtGeneratorMatrix" rows="5">
1 1 1 1 1 1 1
1 0 0 0 1 0 1
1 1 0 0 0 1 0
0 1 1 0 0 0 1</textarea>
			</td>
		</tr>
		<tr>
			<td> </td> 
			<td> <input type="button" id="btnWriteFormula" value="Matrisi Yaz" /> </td>
		</tr>
		</table>

		<div id="divResult"></div>
		
		
		
		<script type="text/javascript">
			$(document).ready(function () {
				$("input[type='button']").click(function (e) {
					if (e.target.id == "btnWriteFormula") {

						var factorial = function(a) { var v = 1; for (var i=1; i <= a; i++) v = v * i; return v; }
						var combination = function(n,k) { return factorial(n) / (factorial(n-k) * factorial(k)); }
						var find_weight = function(vector) { var v = 0; for (var i=0; i < vector.length; i++) if (vector[i]!=0)v++; return v; }
						var find_total = function(vector) { var v = 0; for (var i=0; i < vector.length; i++) v += vector[i]; return v; }

						
						var q = parseInt($('#txtDegree').val());
						//var arr= eval($('#txtGeneratorMatrix').val());
						var text = $('#txtGeneratorMatrix').val();
						var arr = ReadMatrix(text);
						var mat = new Matrix(arr);
						var processor = new MatrixCalculator(q);
						var matGen = new MatrixGenerator(q);
						var code = new ErrorCorrectingCode(mat, q);

						$("#divResult").html("");
						var info = "\\begin{eqnarray*}";
						info += "q&=&" + code.q + " \\\\";
						info += "n&=&" + code.n + " \\\\";
						info += "k&=&" + code.k + " \\\\";
						info += "M&=&" + code.M + " \\\\";
						info += "\\end{eqnarray*}";
						AddFormula("divResult", "MathOutputInfo", info);
						$("#divResult").append("<br />");
						
						
						var generator_text = "G=" + code.Generator.ToLatex(true);
						AddFormula("divResult", "MathOutputGenerator", generator_text);
						$("#divResult").append("<br />");
						
						var weights = Array(code.n+1).fill(0);
						var weights_detailed = Array(code.k+1);
						for (var i = 0; i < weights_detailed.length; i++)
							weights_detailed[i] = Array(code.n+1).fill(0);
							
						// Codewords begin
						var codeWordsText = "\\begin{array}{ccc} word & codeword & weight \\\\ \\hline";
						for (var i = 0; i < code.M; i++) {

							var word = code.GetWord(i)
							var sfw = code.CalculateCodeword(word);

							var word_orj = word.Text;
							var word_cod = sfw.Text;
							var word_weight = "w=" + sfw.weight;
							weights[sfw.weight] += 1;
							weights_detailed[word.weight][sfw.weight] += 1;
							
							//var word_csf = sfw.Text;
							//codeWordsText +=  + "\\rightarrow" +  + " | " + ;
							codeWordsText += word_orj + "&" + word_cod + "&" + word_weight;
							if(i != code.M-1)
								codeWordsText += "\\\\";
						}
						codeWordsText += "\\end{array}";
						if (code.M < 100) {
							AddFormula("divResult", "MathOutputCodewords", codeWordsText);
						}
						// Codewords end
						
						
						
						//var sum_of_rows = new MatrixCalculator().SumRows(code.Generator);
						//AddFormula("divResult", "SumOfRows", sum_of_rows.ToLatex());
						
						//var sum_of_cols = new MatrixCalculator().SumCols(code.Generator);
						//AddFormula("divResult", "SumOfCols", sum_of_cols.ToLatex());
						
						// Tablo begin
						var titles = [];
						var values = [];
						var limits = [];
						var max = 0;
						for (var i = code.n; i >= 0; i--) {
							var val = combination(code.n,i);
							titles.push("x^{" + i + "}");
							values.push("{" + code.n + "}\\choose{" + i + "}");
							limits.push(val);
							max = Math.max(val, max);
						}
						
						var coeficients = [1];
						for (var i = 1; i < limits.length; i++) 
							coeficients.push((limits[i-1] + 1) *  coeficients[i-1]);
						var length = (limits[limits.length-1] + 1) * coeficients[coeficients.length-1];
						
						weights = weights.reverse();
						var sum = 0;
						for (var i = 0; i < weights.length; i++) {
							sum += weights[i];
							if (weights[i] == 0)
								weights[i] = "";
						}
						weights.push(sum);
						
						titles.push("toplam");
						values.push("2^{" + code.n + "}");
						limits.push(Math.pow(2, code.n));
						var table = [titles, values, limits, weights];
						for (var i = 0; i < weights_detailed.length; i++) {
							weights_detailed[i] = weights_detailed[i].reverse();
							sum = 0;
							for (var j = 0; j < weights_detailed[i].length; j++) {
								sum += weights_detailed[i][j];
								if (weights_detailed[i][j] == 0)
									weights_detailed[i][j] = "";
							}
							weights_detailed[i].push(sum);
							weights_detailed[i].push(i);
							table.push(weights_detailed[i]);
						}
						
						var colCount = values.length+1;
						var rowCount = table.length;
						CreateTable("divResult", "result", colCount, rowCount);
						for (var i = 0; i < colCount; i++) {
							for (var j = 0; j < rowCount; j++) {
								var cellName = "td_result_" + i + "_"+ j;
								var text = table[j][i];
								if (text != null)
									AddFormula(cellName, cellName, text);
							}
						}
						$('#tr_result_0').children('td, th').css('background-color','#ede06a');
						$('#tr_result_1').children('td, th').css('background-color','#ede06a');
						$('#tr_result_2').children('td, th').css('background-color','#ede06a');
						$('#tr_result_3').children('td, th').css('background-color','#4a874b');
						
						// Tablo end
					}
				});
			});
		</script>

	</body>
</html>
